import _objectSpread from "reshow-runtime/es/helpers/objectSpread";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { isValidElement, cloneElement, PureComponent } from 'react';
import { connect } from 'reshow-flux';
import { SemanticUI } from 'react-atomic-molecule';
import scrollStore from '../../src/stores/scrollStore';
import fastScrollStore from '../../src/stores/fastScrollStore';

var ScrollReceiver =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(ScrollReceiver, _PureComponent);

  function ScrollReceiver() {
    _classCallCheck(this, ScrollReceiver);

    return _possibleConstructorReturn(this, _getPrototypeOf(ScrollReceiver).apply(this, arguments));
  }

  _createClass(ScrollReceiver, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          atom = _this$props.atom,
          container = _this$props.container,
          scrollMargin = _this$props.scrollMargin,
          targetId = _this$props.targetId,
          isScrollReceiver = _this$props.isScrollReceiver,
          noDelay = _this$props.noDelay,
          children = _this$props.children,
          resetProps = _objectWithoutProperties(_this$props, ["atom", "container", "scrollMargin", "targetId", "isScrollReceiver", "noDelay", "children"]);

      if (!isValidElement(container)) {
        return React.createElement(SemanticUI, resetProps, children);
      }

      var targetInfo = _objectSpread({}, this.state, {
        targetId: targetId
      });

      var thisChildren = children;

      if (!thisChildren) {
        thisChildren = container.props.children;
      }

      return cloneElement(container, _objectSpread({}, resetProps, {
        targetInfo: targetInfo
      }), thisChildren);
    }
  }], [{
    key: "getStores",
    value: function getStores(props) {
      return props.noDelay ? [fastScrollStore] : [scrollStore];
    }
  }, {
    key: "calculateState",
    value: function calculateState(prevState, props) {
      var noDelay = props.noDelay,
          targetId = props.targetId,
          scrollMargin = props.scrollMargin;
      var store = noDelay ? fastScrollStore : scrollStore;
      var state = store.getState();
      var isShown = prevState && prevState.isShown || false;
      var pos = store.getOffset(targetId, store.storeName) || {};
      var scrollInfo = store.getMap('scroll');
      var scrollTop = scrollInfo.top;

      if (pos.isOnScreen) {
        isShown = true;
      }

      var active = 'undefined' !== typeof targetId && targetId === state.get('m' + scrollMargin);

      if (!isNaN(scrollMargin)) {
        store.addMargin(scrollMargin);
      }

      return _objectSpread({}, pos, {
        active: active,
        scrollTop: scrollTop,
        scrollInfo: scrollInfo,
        isShown: isShown
      });
    }
  }]);

  return ScrollReceiver;
}(PureComponent);

_defineProperty(ScrollReceiver, "defaultProps", {
  scrollMargin: 'default',
  isScrollReceiver: true,
  noDelay: false
});

export default connect(ScrollReceiver, {
  withProps: true
});